#

API Docs for: 2.0.0
Show: Inherited Protected Private Deprecated

# Spine Class

Uses

- EventTarget

Extends DisplayObjectContainer
Defined in: `src/pixi/loaders/SpineLoader.js:10`
Module: PIXI

The Spine loader is used to load in JSON spine data To generate the data you need to use http://esotericsoftware.com/ and export in the "JSON" format Due to a clash of names You will need to change the extension of the spine file from .json to .anim for it to load See example 12 (http://www.goodboydigital.com/pixijs/examples/12/) to see a working example and check out the source You will need to generate a sprite sheet to accompany the spine data When loaded this class will dispatch a "loaded" event

## Constructor

### `Spine`

(

- `url`

)

Defined in `src/pixi/loaders/SpineLoader.js:10`

#### Parameters:

- `url` String

  The url of the spine anim file to be used

- Index
- Methods
- Properties

## Item Index

### Methods

- _destroyCachedSprite
- _generateCachedSprite
- _renderCachedSprite
- _renderCanvas
- _renderWebGL
- addChild
- addChildAt
- click
- emit
- generateTexture
- getBounds
- getChildAt
- getChildIndex
- getLocalBounds
- listeners
- load
- mixin
- mousedown
- mouseout
- mouseover
- mouseup
- mouseupoutside
- off
- on
- once
- onLoaded
- removeAllListeners
- removeChild
- removeChildAt
- removeChildren
- removeStageReference
- rightclick
- rightdown
- rightup
- rightupoutside
- setChildIndex
- setStageReference
- swapChildren
- tap
- toGlobal
- toLocal
- touchend
- touchendoutside
- touchstart
- updateCache

### Properties

- _bounds
- _cacheAsBitmap
- _cacheIsDirty
- _cr
- _currentBounds
- _interactive
- _sr
- alpha
- buttonMode
- cacheAsBitmap
- children
- crossorigin
- defaultCursor
- filterArea
- filters
- height
- hitArea
- interactive
- loaded
- mask
- parent
- pivot
- position
- renderable
- rotation
- scale
- stage
- url
- visible
- width
- worldAlpha
- worldTransform
- worldVisible
- x
- y

## Methods

### `_destroyCachedSprite`

() private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:681`

Destroys the cached sprite.

### `_generateCachedSprite`

() private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:639`

Internal method.

### `_renderCachedSprite`

(

- `renderSession`

)
private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:618`

Internal method.

#### Parameters:

- `renderSession` Object

  The render session

### `_renderCanvas`

(

- `renderSession`

)
private

Inherited from DisplayObject but overwritten in `src/pixi/display/DisplayObjectContainer.js:480`

Renders the object using the Canvas renderer

#### Parameters:

- `renderSession` RenderSession

### `_renderWebGL`

(

- `renderSession`

)
private

Inherited from DisplayObject but overwritten in `src/pixi/display/DisplayObjectContainer.js:421`

Renders the object using the WebGL renderer

#### Parameters:

- `renderSession` RenderSession

### `addChild`

(

- `child`

)
DisplayObject

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:86`

Adds a child to the container.

#### Parameters:

- `child` DisplayObject

  The DisplayObject to add to the container

#### Returns:

DisplayObject:

The child that was added.

### `addChildAt`

(

- `child`
- `index`

)
DisplayObject

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:98`

Adds a child to the container at a specified index. If the index is out of bounds an error will be thrown

#### Parameters:

- `child` DisplayObject

  The child to add

- `index` Number

  The index to place the child in

#### Returns:

DisplayObject:

The child that was added.

### `click`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:233`

A callback that is used when the users clicks on the displayObject with their mouse's left button

#### Parameters:

- `interactionData` InteractionData

### `emit`

(

- `eventName`

)
Boolean

Inherited from EventTarget: `src/pixi/utils/EventTarget.js:54`

Emit an event to all registered event listeners.

#### Parameters:

- `eventName` String

  The name of the event.

#### Returns:

Boolean:

Indication if we've emitted an event.

### `generateTexture`

(

- `resolution`
- `scaleMode`
- `renderer`

)
Texture

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:555`

Useful function that returns a texture of the displayObject object that can then be used to create sprites This can be quite useful if your displayObject is static / complicated and needs to be reused multiple times.

#### Parameters:

- `resolution` Number

  The resolution of the texture being generated

- `scaleMode` Number

  Should be one of the PIXI.scaleMode consts

- `renderer` CanvasRenderer | WebGLRenderer

  The renderer used to generate the texture.

#### Returns:

Texture:

a texture of the graphics object

### `getBounds`

() Rectangle

Inherited from DisplayObject but overwritten in `src/pixi/display/DisplayObjectContainer.js:293`

Retrieves the bounds of the displayObjectContainer as a rectangle. The bounds calculation takes all visible children into consideration.

#### Returns:

Rectangle:

The rectangular bounding area

### `getChildAt`

(

- `index`

)
DisplayObject

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:189`

Returns the child at the specified index

#### Parameters:

- `index` Number

  The index to get the child from

#### Returns:

DisplayObject:

The child at the given index, if any.

### `getChildIndex`

(

- `child`

)
Number

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:154`

Returns the index position of a child DisplayObject instance

#### Parameters:

- `child` DisplayObject

  The DisplayObject instance to identify

#### Returns:

Number:

The index position of the child display object to identify

### `getLocalBounds`

() Rectangle

Inherited from DisplayObject but overwritten in `src/pixi/display/DisplayObjectContainer.js:360`

Retrieves the non-global local bounds of the displayObjectContainer as a rectangle. The calculation takes all visible children into consideration.

#### Returns:

Rectangle:

The rectangular bounding area

### `listeners`

(

- `eventName`

)
Array

Inherited from EventTarget: `src/pixi/utils/EventTarget.js:41`

Return a list of assigned event listeners.

#### Parameters:

- `eventName` String

  The events that should be listed.

#### Returns:

Array:

An array of listener functions

### `load`

()

Defined in `src/pixi/loaders/SpineLoader.js:56`

Loads the JSON data

### `mixin`

(

- `object`

)

Inherited from EventTarget: `src/pixi/utils/EventTarget.js:34`

Mixes in the properties of the EventTarget prototype onto another object

#### Parameters:

- `object` Object

  The obj to mix into

### `mousedown`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:239`

A callback that is used when the user clicks the mouse's left button down over the sprite

#### Parameters:

- `interactionData` InteractionData

### `mouseout`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:226`

A callback that is used when the users mouse leaves the displayObject

#### Parameters:

- `interactionData` InteractionData

### `mouseover`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:220`

A callback that is used when the users mouse rolls over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `mouseup`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:245`

A callback that is used when the user releases the mouse's left button that was over the displayObject for this callback to be fired, the mouse's left button must have been pressed down over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `mouseupoutside`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:252`

A callback that is used when the user releases the mouse's left button that was over the displayObject but is no longer over the displayObject for this callback to be fired, the mouse's left button must have been pressed down over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `off`

(

- `eventName`
- `callback`

)

Inherited from EventTarget: `src/pixi/utils/EventTarget.js:143`

Remove event listeners.

#### Parameters:

- `eventName` String

  The event we want to remove.

- `callback` Function

  The listener that we need to find.

### `on`

(

- `eventName`
- `callback`

)

Inherited from EventTarget: `src/pixi/utils/EventTarget.js:107`

Register a new EventListener for the given event.

#### Parameters:

- `eventName` String

  Name of the event.

- `callback` Functon

  fn Callback function.

### `once`

(

- `eventName`
- `callback`

)

Inherited from EventTarget: `src/pixi/utils/EventTarget.js:124`

Add an EventListener that's only called once.

#### Parameters:

- `eventName` String

  Name of the event.

- `callback` Function

  Callback function.

### `onLoaded`

() private

Defined in `src/pixi/loaders/SpineLoader.js:72`

Invoked when JSON file is loaded.

### `removeAllListeners`

(

- `eventName`

)

Inherited from EventTarget: `src/pixi/utils/EventTarget.js:173`

Remove all listeners or only the listeners for the specified event.

#### Parameters:

- `eventName` String

  The event you want to remove all listeners for.

### `removeChild`

(

- `child`

)
DisplayObject

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:206`

Removes a child from the container.

#### Parameters:

- `child` DisplayObject

  The DisplayObject to remove

#### Returns:

DisplayObject:

The child that was removed.

### `removeChildAt`

(

- `index`

)
DisplayObject

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:221`

Removes a child from the specified index position.

#### Parameters:

- `index` Number

  The index to get the child from

#### Returns:

DisplayObject:

The child that was removed.

### `removeChildren`

(

- `beginIndex`
- `endIndex`

)

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:239`

Removes all children from this container that are within the begin and end indexes.

#### Parameters:

- `beginIndex` Number

  The beginning position. Default value is 0.

- `endIndex` Number

  The ending position. Default value is size of the container.

### `removeStageReference`

()

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:402`

Removes the current stage reference from the container and all of its children.

### `rightclick`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:260`

A callback that is used when the users clicks on the displayObject with their mouse's right button

#### Parameters:

- `interactionData` InteractionData

### `rightdown`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:266`

A callback that is used when the user clicks the mouse's right button down over the sprite

#### Parameters:

- `interactionData` InteractionData

### `rightup`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:272`

A callback that is used when the user releases the mouse's right button that was over the displayObject for this callback to be fired the mouse's right button must have been pressed down over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `rightupoutside`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:279`

A callback that is used when the user releases the mouse's right button that was over the displayObject but is no longer over the displayObject for this callback to be fired, the mouse's right button must have been pressed down over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `setChildIndex`

(

- `child`
- `index`

)

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:171`

Changes the position of an existing child in the display object container

#### Parameters:

- `child` DisplayObject

  The child DisplayObject instance for which you want to change the index number

- `index` Number

  The resulting index number for the child display object

### `setStageReference`

(

- `stage`

)

Inherited from DisplayObject but overwritten in `src/pixi/display/DisplayObjectContainer.js:384`

Sets the containers Stage reference. This is the Stage that this object, and all of its children, is connected to.

#### Parameters:

- `stage` Stage

  the stage that the container will have as its current stage reference

### `swapChildren`

(

- `child`
- `child2`

)

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:129`

Swaps the position of 2 Display Objects within this container.

#### Parameters:

- `child` DisplayObject
- `child2` DisplayObject

### `tap`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:290`

A callback that is used when the users taps on the sprite with their finger basically a touch version of click

#### Parameters:

- `interactionData` InteractionData

### `toGlobal`

(

- `position`

)
Point

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:585`

Calculates the global position of the display object

#### Parameters:

- `position` Point

  The world origin to calculate from

#### Returns:

Point:

A point object representing the position of this object

### `toLocal`

(

- `position`
- `[from]`

)
Point

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:598`

Calculates the local position of the display object relative to another point

#### Parameters:

- `position` Point

  The world origin to calculate from

- `[from]` DisplayObject optional

  The DisplayObject to calculate the global position from

#### Returns:

Point:

A point object representing the position of this object

### `touchend`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:303`

A callback that is used when the user releases a touch over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `touchendoutside`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:309`

A callback that is used when the user releases the touch that was over the displayObject for this callback to be fired, The touch must have started over the sprite

#### Parameters:

- `interactionData` InteractionData

### `touchstart`

(

- `interactionData`

)

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:297`

A callback that is used when the user touches over the displayObject

#### Parameters:

- `interactionData` InteractionData

### `updateCache`

()

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:575`

Generates and updates the cached sprite for this object.

## Properties

### `_bounds`

Rectangle private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:170`

The original, cached bounds of the object

### `_cacheAsBitmap`

Boolean private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:197`

Cached internal flag.

### `_cacheIsDirty`

Boolean private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:206`

Cached internal flag.

### `_cr`

Number private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:152`

cached sin rotation and cos rotation

### `_currentBounds`

Rectangle private

Inherited from DisplayObject but overwritten in `src/pixi/display/DisplayObject.js:179`

The most up-to-date bounds of the object

### `_interactive`

Boolean private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:114`

[read-only] Whether or not the object is interactive, do not toggle directly! use the `interactive` property

### `_sr`

Number private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:143`

cached sin rotation and cos rotation

### `alpha`

Number

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:46`

The opacity of the object.

### `buttonMode`

Boolean

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:71`

This is used to indicate if the displayObject should display a mouse hand cursor on rollover

### `cacheAsBitmap`

Boolean

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:417`

Set if this display object is cached as a bitmap. This basically takes a snap shot of the display object as it is at that moment. It can provide a performance benefit for complex static displayObjects. To remove simply set this property to 'null'

### `children`

Array

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:17`

[read-only] The array of children of this container.

### `crossorigin`

Boolean

Defined in `src/pixi/loaders/SpineLoader.js:34`

Whether the requests should be treated as cross origin

### `defaultCursor`

String

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:124`

This is the cursor that will be used when the mouse is over this object. To enable this the element must have interaction = true and buttonMode = true

### `filterArea`

Rectangle

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:161`

The area the filter is applied to like the hitArea this is used as more of an optimisation rather than figuring out the dimensions of the displayObject each frame you can set this rectangle

### `filters`

Array An array of filters

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:381`

Sets the filters for the displayObject.

- IMPORTANT: This is a webGL only feature and will be ignored by the canvas renderer. To remove filters simply set this property to 'null'

### `height`

Number

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:59`

The height of the displayObjectContainer, setting this will actually modify the scale to achieve the value set

### `hitArea`

Rectangle | Circle | Ellipse | Polygon

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:62`

This is the defined area that will pick up mouse / touch events. It is null by default. Setting it is a neat way of optimising the hitTest function that the interactionManager will use (as it will not need to hit test all the children)

### `interactive`

Boolean

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:320`

Indicates if the sprite will have touch and mouse interactivity. It is false by default

Default: false

### `loaded`

Boolean

Defined in `src/pixi/loaders/SpineLoader.js:42`

[read-only] Whether the data has loaded yet

### `mask`

Graphics

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:361`

Sets a mask for the displayObject. A mask is an object that limits the visibility of an object to the shape of the mask applied to it. In PIXI a regular mask must be a PIXI.Graphics object. This allows for much faster masking in canvas as it utilises shape clipping. To remove a mask, set this property to null.

### `parent`

DisplayObjectContainer

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:87`

[read-only] The display object container that contains this display object.

### `pivot`

Point

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:30`

The pivot point of the displayObject that it rotates around

### `position`

Point

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:14`

The coordinate of the object relative to the local coordinates of the parent.

### `renderable`

Boolean

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:79`

Can this object be rendered

### `rotation`

Number

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:38`

The rotation of the object in radians.

### `scale`

Point

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:22`

The scale factor of the object.

### `stage`

Stage

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:96`

[read-only] The stage the display object is connected to, or undefined if it is not connected to the stage.

### `url`

String

Defined in `src/pixi/loaders/SpineLoader.js:26`

The url of the bitmap font data

### `visible`

Boolean

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:54`

The visibility of the object.

### `width`

Number

Inherited from DisplayObjectContainer: `src/pixi/display/DisplayObjectContainer.js:31`

The width of the displayObjectContainer, setting this will actually modify the scale to achieve the value set

### `worldAlpha`

Number

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:105`

[read-only] The multiplied alpha of the displayObject

### `worldTransform`

Matrix private

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:133`

[read-only] Current transform of the object based on world (parent) factors

### `worldVisible`

Boolean

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:340`

[read-only] Indicates if the sprite is globally visible.

### `x`

Number

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:728`

The position of the displayObject on the x axis relative to the local coordinates of the parent.

### `y`

Number

Inherited from DisplayObject: `src/pixi/display/DisplayObject.js:743`

The position of the displayObject on the y axis relative to the local coordinates of the parent.